"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _carbonComponentsReact = require("carbon-components-react");

var _prepareProps = _interopRequireDefault(require("../prepare-props"));

var _helperTextBlock = _interopRequireDefault(require("../helper-text-block/helper-text-block"));

var _excluded = ["input", "datePickerType", "meta", "DatePickerProps", "validateOnMount", "helperText", "WrapperProps"];

var DatePicker = function DatePicker(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])((0, _prepareProps["default"])(props)),
      input = _useFieldApi.input,
      _useFieldApi$datePick = _useFieldApi.datePickerType,
      datePickerType = _useFieldApi$datePick === void 0 ? 'single' : _useFieldApi$datePick,
      meta = _useFieldApi.meta,
      DatePickerProps = _useFieldApi.DatePickerProps,
      validateOnMount = _useFieldApi.validateOnMount,
      helperText = _useFieldApi.helperText,
      WrapperProps = _useFieldApi.WrapperProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded);

  var invalid = (meta.touched || validateOnMount) && (meta.error || meta.submitError);
  var warnText = (meta.touched || validateOnMount) && meta.warning;
  return /*#__PURE__*/_react["default"].createElement("div", WrapperProps, /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.DatePicker, (0, _extends2["default"])({}, input, {
    datePickerType: datePickerType
  }, DatePickerProps), /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.DatePickerInput, (0, _extends2["default"])({
    id: input.name,
    invalid: Boolean(invalid),
    invalidText: invalid ? invalid : ''
  }, rest))), /*#__PURE__*/_react["default"].createElement(_helperTextBlock["default"], {
    helperText: !invalid && helperText,
    warnText: warnText
  }));
};

var _default = DatePicker;
exports["default"] = _default;