import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["input", "datePickerType", "meta", "DatePickerProps", "validateOnMount", "helperText", "WrapperProps"];
import React from 'react';
import useFieldApi from "@data-driven-forms/react-form-renderer/use-field-api";
import { DatePicker as CarbonDatePicker, DatePickerInput } from 'carbon-components-react';
import prepareProps from '../prepare-props';
import HelperTextBlock from '../helper-text-block/helper-text-block';

var DatePicker = function DatePicker(props) {
  var _useFieldApi = useFieldApi(prepareProps(props)),
      input = _useFieldApi.input,
      _useFieldApi$datePick = _useFieldApi.datePickerType,
      datePickerType = _useFieldApi$datePick === void 0 ? 'single' : _useFieldApi$datePick,
      meta = _useFieldApi.meta,
      DatePickerProps = _useFieldApi.DatePickerProps,
      validateOnMount = _useFieldApi.validateOnMount,
      helperText = _useFieldApi.helperText,
      WrapperProps = _useFieldApi.WrapperProps,
      rest = _objectWithoutProperties(_useFieldApi, _excluded);

  var invalid = (meta.touched || validateOnMount) && (meta.error || meta.submitError);
  var warnText = (meta.touched || validateOnMount) && meta.warning;
  return /*#__PURE__*/React.createElement("div", WrapperProps, /*#__PURE__*/React.createElement(CarbonDatePicker, _extends({}, input, {
    datePickerType: datePickerType
  }, DatePickerProps), /*#__PURE__*/React.createElement(DatePickerInput, _extends({
    id: input.name,
    invalid: Boolean(invalid),
    invalidText: invalid ? invalid : ''
  }, rest))), /*#__PURE__*/React.createElement(HelperTextBlock, {
    helperText: !invalid && helperText,
    warnText: warnText
  }));
};

export default DatePicker;