import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
var _excluded = ["remove"],
    _excluded2 = ["remove"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

import React, { memo } from 'react';
import isEqual from 'lodash/isEqual';
import clsx from 'clsx';
import { createUseStyles } from "react-jss/dist/react-jss.esm.js";
import useFieldApi from "@data-driven-forms/react-form-renderer/use-field-api";
import useFormApi from "@data-driven-forms/react-form-renderer/use-form-api";
import FieldArrayFF from "@data-driven-forms/react-form-renderer/field-array";
import { Button, FormGroup } from 'carbon-components-react';
import { AddAlt32, Subtract32 } from '@carbon/icons-react';
import prepareProps from '../prepare-props';
var useStyles = createUseStyles({
  add: {
    marginTop: 16
  },
  addContainer: {
    width: '100%',
    display: 'flex',
    flexDirection: 'row-reverse'
  },
  remove: {
    marginTop: 8,
    marginBottom: 8
  },
  formGroup: {
    '.bx--form__requirements': {
      color: '#da1e28'
    }
  }
});
var ArrayItem = /*#__PURE__*/memo(function (_ref) {
  var remove = _ref.remove,
      fields = _ref.fields,
      name = _ref.name,
      removeText = _ref.removeText,
      buttonDisabled = _ref.buttonDisabled,
      _ref$RemoveButtonProp = _ref.RemoveButtonProps,
      RemoveButtonProps = _ref$RemoveButtonProp === void 0 ? {} : _ref$RemoveButtonProp,
      _ref$ArrayItemProps = _ref.ArrayItemProps,
      ArrayItemProps = _ref$ArrayItemProps === void 0 ? {} : _ref$ArrayItemProps;
  var formOptions = useFormApi();

  var _useStyles = useStyles(),
      removeStyle = _useStyles.remove;

  var editedFields = fields.map(function (field) {
    return _objectSpread(_objectSpread({}, field), field.name ? {
      name: "".concat(name, ".").concat(field.name)
    } : {
      name: name
    });
  });
  return /*#__PURE__*/React.createElement("div", ArrayItemProps, formOptions.renderForm(editedFields, formOptions), /*#__PURE__*/React.createElement(Button, _extends({
    disabled: buttonDisabled,
    renderIcon: Subtract32,
    id: "remove-".concat(name),
    kind: "danger",
    onClick: remove
  }, RemoveButtonProps, {
    className: clsx(removeStyle, RemoveButtonProps.className)
  }), removeText));
}, function (_ref2, _ref3) {
  var _prevRemove = _ref2.remove,
      prev = _objectWithoutProperties(_ref2, _excluded);

  var _nextRemove = _ref3.remove,
      next = _objectWithoutProperties(_ref3, _excluded2);

  return isEqual(prev, next);
});

var FieldArray = function FieldArray(props) {
  var _useFieldApi = useFieldApi(prepareProps(props)),
      _useFieldApi$AddConta = _useFieldApi.AddContainerProps,
      AddContainerProps = _useFieldApi$AddConta === void 0 ? {} : _useFieldApi$AddConta,
      _useFieldApi$AddButto = _useFieldApi.AddButtonProps,
      AddButtonProps = _useFieldApi$AddButto === void 0 ? {} : _useFieldApi$AddButto,
      _useFieldApi$FormGrou = _useFieldApi.FormGroupProps,
      FormGroupProps = _useFieldApi$FormGrou === void 0 ? {} : _useFieldApi$FormGrou,
      _useFieldApi$WrapperP = _useFieldApi.WrapperProps,
      WrapperProps = _useFieldApi$WrapperP === void 0 ? {} : _useFieldApi$WrapperP,
      _useFieldApi$ArrayIte = _useFieldApi.ArrayItemProps,
      ArrayItemProps = _useFieldApi$ArrayIte === void 0 ? {} : _useFieldApi$ArrayIte,
      _useFieldApi$RemoveBu = _useFieldApi.RemoveButtonProps,
      RemoveButtonProps = _useFieldApi$RemoveBu === void 0 ? {} : _useFieldApi$RemoveBu,
      defaultItem = _useFieldApi.defaultItem,
      _useFieldApi$maxItems = _useFieldApi.maxItems,
      maxItems = _useFieldApi$maxItems === void 0 ? Infinity : _useFieldApi$maxItems,
      _useFieldApi$minItems = _useFieldApi.minItems,
      minItems = _useFieldApi$minItems === void 0 ? 0 : _useFieldApi$minItems,
      fields = _useFieldApi.fields,
      input = _useFieldApi.input,
      arrayValidator = _useFieldApi.arrayValidator,
      labelText = _useFieldApi.labelText,
      buttonLabels = _useFieldApi.buttonLabels,
      _useFieldApi$noItemsM = _useFieldApi.noItemsMessage,
      noItemsMessage = _useFieldApi$noItemsM === void 0 ? 'No items' : _useFieldApi$noItemsM,
      meta = _useFieldApi.meta,
      validateOnMount = _useFieldApi.validateOnMount;

  var _useStyles2 = useStyles(),
      formGroup = _useStyles2.formGroup,
      addContainer = _useStyles2.addContainer,
      add = _useStyles2.add;

  var buttonLabelsFinal = _objectSpread({
    add: 'Add',
    remove: 'Remove'
  }, buttonLabels);

  var invalid = (meta.touched || validateOnMount) && !Array.isArray(meta.error) && (meta.error || meta.submitError);
  return /*#__PURE__*/React.createElement(FormGroup, _extends({
    legendText: labelText || '',
    invalid: Boolean(invalid),
    message: Boolean(invalid),
    messageText: invalid || ''
  }, FormGroupProps, {
    className: clsx(formGroup, FormGroupProps.className)
  }), /*#__PURE__*/React.createElement(FieldArrayFF, {
    name: input.name,
    validate: arrayValidator
  }, function (fieldArrayProps) {
    return /*#__PURE__*/React.createElement("div", WrapperProps, fieldArrayProps.fields.length === 0 && noItemsMessage, fieldArrayProps.fields.map(function (name, index) {
      return /*#__PURE__*/React.createElement(ArrayItem, {
        removeText: buttonLabelsFinal.remove,
        key: index,
        remove: function remove() {
          return fieldArrayProps.fields.remove(index);
        },
        name: name,
        fields: fields,
        buttonDisabled: minItems >= fieldArrayProps.fields.length,
        ArrayItemProps: ArrayItemProps,
        RemoveButtonProps: RemoveButtonProps
      });
    }), /*#__PURE__*/React.createElement("div", _extends({}, AddContainerProps, {
      className: clsx(addContainer, AddContainerProps.className)
    }), /*#__PURE__*/React.createElement(Button, _extends({
      disabled: fieldArrayProps.fields.length >= maxItems,
      renderIcon: AddAlt32,
      id: "add-".concat(input.name),
      onClick: function onClick() {
        return fieldArrayProps.fields.push(defaultItem);
      }
    }, AddButtonProps, {
      className: clsx(add, AddButtonProps.className)
    }), buttonLabelsFinal.add)));
  }));
};

export default FieldArray;