"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _clsx = _interopRequireDefault(require("clsx"));

var _reactJssCjs = require("react-jss/dist/react-jss.cjs.js");

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _useFormApi = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-form-api"));

var _fieldArray = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/field-array"));

var _carbonComponentsReact = require("carbon-components-react");

var _iconsReact = require("@carbon/icons-react");

var _prepareProps = _interopRequireDefault(require("../prepare-props"));

var _excluded = ["remove"],
    _excluded2 = ["remove"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var useStyles = (0, _reactJssCjs.createUseStyles)({
  add: {
    marginTop: 16
  },
  addContainer: {
    width: '100%',
    display: 'flex',
    flexDirection: 'row-reverse'
  },
  remove: {
    marginTop: 8,
    marginBottom: 8
  },
  formGroup: {
    '.bx--form__requirements': {
      color: '#da1e28'
    }
  }
});
var ArrayItem = /*#__PURE__*/(0, _react.memo)(function (_ref) {
  var remove = _ref.remove,
      fields = _ref.fields,
      name = _ref.name,
      removeText = _ref.removeText,
      buttonDisabled = _ref.buttonDisabled,
      _ref$RemoveButtonProp = _ref.RemoveButtonProps,
      RemoveButtonProps = _ref$RemoveButtonProp === void 0 ? {} : _ref$RemoveButtonProp,
      _ref$ArrayItemProps = _ref.ArrayItemProps,
      ArrayItemProps = _ref$ArrayItemProps === void 0 ? {} : _ref$ArrayItemProps;
  var formOptions = (0, _useFormApi["default"])();

  var _useStyles = useStyles(),
      removeStyle = _useStyles.remove;

  var editedFields = fields.map(function (field) {
    return _objectSpread(_objectSpread({}, field), field.name ? {
      name: "".concat(name, ".").concat(field.name)
    } : {
      name: name
    });
  });
  return /*#__PURE__*/_react["default"].createElement("div", ArrayItemProps, formOptions.renderForm(editedFields, formOptions), /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.Button, (0, _extends2["default"])({
    disabled: buttonDisabled,
    renderIcon: _iconsReact.Subtract32,
    id: "remove-".concat(name),
    kind: "danger",
    onClick: remove
  }, RemoveButtonProps, {
    className: (0, _clsx["default"])(removeStyle, RemoveButtonProps.className)
  }), removeText));
}, function (_ref2, _ref3) {
  var _prevRemove = _ref2.remove,
      prev = (0, _objectWithoutProperties2["default"])(_ref2, _excluded);
  var _nextRemove = _ref3.remove,
      next = (0, _objectWithoutProperties2["default"])(_ref3, _excluded2);
  return (0, _isEqual["default"])(prev, next);
});

var FieldArray = function FieldArray(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])((0, _prepareProps["default"])(props)),
      _useFieldApi$AddConta = _useFieldApi.AddContainerProps,
      AddContainerProps = _useFieldApi$AddConta === void 0 ? {} : _useFieldApi$AddConta,
      _useFieldApi$AddButto = _useFieldApi.AddButtonProps,
      AddButtonProps = _useFieldApi$AddButto === void 0 ? {} : _useFieldApi$AddButto,
      _useFieldApi$FormGrou = _useFieldApi.FormGroupProps,
      FormGroupProps = _useFieldApi$FormGrou === void 0 ? {} : _useFieldApi$FormGrou,
      _useFieldApi$WrapperP = _useFieldApi.WrapperProps,
      WrapperProps = _useFieldApi$WrapperP === void 0 ? {} : _useFieldApi$WrapperP,
      _useFieldApi$ArrayIte = _useFieldApi.ArrayItemProps,
      ArrayItemProps = _useFieldApi$ArrayIte === void 0 ? {} : _useFieldApi$ArrayIte,
      _useFieldApi$RemoveBu = _useFieldApi.RemoveButtonProps,
      RemoveButtonProps = _useFieldApi$RemoveBu === void 0 ? {} : _useFieldApi$RemoveBu,
      defaultItem = _useFieldApi.defaultItem,
      _useFieldApi$maxItems = _useFieldApi.maxItems,
      maxItems = _useFieldApi$maxItems === void 0 ? Infinity : _useFieldApi$maxItems,
      _useFieldApi$minItems = _useFieldApi.minItems,
      minItems = _useFieldApi$minItems === void 0 ? 0 : _useFieldApi$minItems,
      fields = _useFieldApi.fields,
      input = _useFieldApi.input,
      arrayValidator = _useFieldApi.arrayValidator,
      labelText = _useFieldApi.labelText,
      buttonLabels = _useFieldApi.buttonLabels,
      _useFieldApi$noItemsM = _useFieldApi.noItemsMessage,
      noItemsMessage = _useFieldApi$noItemsM === void 0 ? 'No items' : _useFieldApi$noItemsM,
      meta = _useFieldApi.meta,
      validateOnMount = _useFieldApi.validateOnMount;

  var _useStyles2 = useStyles(),
      formGroup = _useStyles2.formGroup,
      addContainer = _useStyles2.addContainer,
      add = _useStyles2.add;

  var buttonLabelsFinal = _objectSpread({
    add: 'Add',
    remove: 'Remove'
  }, buttonLabels);

  var invalid = (meta.touched || validateOnMount) && !Array.isArray(meta.error) && (meta.error || meta.submitError);
  return /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.FormGroup, (0, _extends2["default"])({
    legendText: labelText || '',
    invalid: Boolean(invalid),
    message: Boolean(invalid),
    messageText: invalid || ''
  }, FormGroupProps, {
    className: (0, _clsx["default"])(formGroup, FormGroupProps.className)
  }), /*#__PURE__*/_react["default"].createElement(_fieldArray["default"], {
    name: input.name,
    validate: arrayValidator
  }, function (fieldArrayProps) {
    return /*#__PURE__*/_react["default"].createElement("div", WrapperProps, fieldArrayProps.fields.length === 0 && noItemsMessage, fieldArrayProps.fields.map(function (name, index) {
      return /*#__PURE__*/_react["default"].createElement(ArrayItem, {
        removeText: buttonLabelsFinal.remove,
        key: index,
        remove: function remove() {
          return fieldArrayProps.fields.remove(index);
        },
        name: name,
        fields: fields,
        buttonDisabled: minItems >= fieldArrayProps.fields.length,
        ArrayItemProps: ArrayItemProps,
        RemoveButtonProps: RemoveButtonProps
      });
    }), /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, AddContainerProps, {
      className: (0, _clsx["default"])(addContainer, AddContainerProps.className)
    }), /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.Button, (0, _extends2["default"])({
      disabled: fieldArrayProps.fields.length >= maxItems,
      renderIcon: _iconsReact.AddAlt32,
      id: "add-".concat(input.name),
      onClick: function onClick() {
        return fieldArrayProps.fields.push(defaultItem);
      }
    }, AddButtonProps, {
      className: (0, _clsx["default"])(add, AddButtonProps.className)
    }), buttonLabelsFinal.add)));
  }));
};

var _default = FieldArray;
exports["default"] = _default;