"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _carbonComponentsReact = require("carbon-components-react");

var _prepareProps = _interopRequireDefault(require("../prepare-props"));

var _excluded = ["input", "meta", "validateOnMount", "labelText"];

var TextField = function TextField(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])((0, _prepareProps["default"])(props)),
      input = _useFieldApi.input,
      meta = _useFieldApi.meta,
      validateOnMount = _useFieldApi.validateOnMount,
      labelText = _useFieldApi.labelText,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded);

  var Component = input.type === 'number' ? _carbonComponentsReact.NumberInput : _carbonComponentsReact.TextInput;

  var setValue = function setValue(e, input) {
    return input.type === 'number' ? e.imaginaryTarget.value : e.target.value;
  };

  var invalid = (meta.touched || validateOnMount) && (meta.error || meta.submitError);
  var warn = (meta.touched || validateOnMount) && meta.warning;
  return /*#__PURE__*/_react["default"].createElement(Component, (0, _extends2["default"])({}, input, {
    key: input.name,
    id: input.name,
    invalid: Boolean(invalid),
    invalidText: invalid || '',
    warn: Boolean(warn),
    warnText: warn || '',
    onChange: function onChange(e) {
      return input.onChange(setValue(e, input));
    }
  }, input.type === 'number' ? {
    label: labelText
  } : {
    labelText: labelText
  }, rest));
};

var _default = TextField;
exports["default"] = _default;