"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _carbonComponentsReact = require("carbon-components-react");

var _helperTextBlock = _interopRequireDefault(require("../helper-text-block/helper-text-block"));

var _excluded = ["WrapperProps", "input", "enhnancedOnBlur", "enhancedOnChange", "finalValue", "invalid", "twelveHoursFormat", "timezones", "helperText", "warnText", "selectFormat", "selectTimezone", "format", "timezone"],
    _excluded2 = ["showAs"];

var TimePickerBase = function TimePickerBase(_ref) {
  var WrapperProps = _ref.WrapperProps,
      input = _ref.input,
      enhnancedOnBlur = _ref.enhnancedOnBlur,
      enhancedOnChange = _ref.enhancedOnChange,
      finalValue = _ref.finalValue,
      invalid = _ref.invalid,
      twelveHoursFormat = _ref.twelveHoursFormat,
      timezones = _ref.timezones,
      helperText = _ref.helperText,
      warnText = _ref.warnText,
      selectFormat = _ref.selectFormat,
      selectTimezone = _ref.selectTimezone,
      format = _ref.format,
      timezone = _ref.timezone,
      rest = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  return /*#__PURE__*/_react["default"].createElement("div", WrapperProps, /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.TimePicker, (0, _extends2["default"])({}, input, enhnancedOnBlur && {
    onBlur: enhnancedOnBlur
  }, enhancedOnChange && {
    onChange: function onChange(e) {
      return enhancedOnChange(e.target.value);
    }
  }, {
    onBlur: enhnancedOnBlur,
    value: finalValue,
    key: input.name,
    id: input.name,
    invalid: Boolean(invalid),
    invalidText: invalid || ''
  }, rest), twelveHoursFormat && /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.TimePickerSelect, {
    defaultValue: format,
    labelText: "Period",
    id: "".concat(rest.id || input.name, "-12h"),
    onChange: function onChange(_ref2) {
      var value = _ref2.target.value;
      return selectFormat(value);
    }
  }, /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.SelectItem, {
    value: "AM",
    text: "AM"
  }), /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.SelectItem, {
    value: "PM",
    text: "PM"
  })), timezones && /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.TimePickerSelect, {
    defaultValue: timezone,
    labelText: "Timezone",
    id: "".concat(rest.id || input.name, "-timezones"),
    onChange: function onChange(_ref3) {
      var value = _ref3.target.value;
      return selectTimezone(value);
    }
  }, timezones.map(function (_ref4) {
    var showAs = _ref4.showAs,
        tz = (0, _objectWithoutProperties2["default"])(_ref4, _excluded2);
    return /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.SelectItem, (0, _extends2["default"])({
      key: tz.value,
      text: tz.label
    }, tz));
  }))), /*#__PURE__*/_react["default"].createElement(_helperTextBlock["default"], {
    helperText: !invalid && helperText,
    warnText: warnText
  }));
};

var _default = TimePickerBase;
exports["default"] = _default;